=== utils/UnicodeData/CMakeLists.txt ===
set(LLVM_LINK_COMPONENTS Support)

add_llvm_utility(UnicodeNameMappingGenerator
    UnicodeNameMappingGenerator.cpp
)
